// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2012, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2012, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */

#include <c_like_solver.hpp>
#include <parser_context.hpp>
#include <c_like_parser.tab.hpp>
#include <flags.hpp>

using namespace std;
using namespace hcsp;

c_like_solver::c_like_solver(std::istream & in,
                             const std::string & file_name,
                             const hcsp_flags & flags,                
                             table_propagator_base::memory_manager& manager)
    : m_context(*this, c_like_scanner_methods::get(), manager, &in, file_name)
{
    m_context.detect_all_diff_enabled(flags.use_all_diff);

    yy::c_like_parser parser(m_context);
    flags.apply(*this);
    parser.set_debug_stream(cout);
    if (parser.parse() != 0)
        throw std::runtime_error(file_name+": Parsing failed");
    if (!m_context.create_constraints(cout))
        throw std::runtime_error(file_name+": Parsing failed");
}
