// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2013 Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2013 Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */

#include <disjoint_propagation_algo.hpp>
#include <clause_propagator.hpp>
#include <sstream>

using namespace std;
using namespace hcsp;

disjoint_propagation_algo_base::print_buffer::print_buffer()
    : m_stream_a(new ostringstream),
      m_stream_b(new ostringstream)
{}

disjoint_propagation_algo_base::print_buffer::~print_buffer()
{}

ostream & disjoint_propagation_algo_base::print_buffer::stream_a()
{
    return *m_stream_a;
}

ostream & disjoint_propagation_algo_base::print_buffer::stream_b()
{
    return *m_stream_b;
}

void disjoint_propagation_algo_base::print_buffer::flush_to(ostream & out)
{
    string a= m_stream_a->str();
    string b= m_stream_b->str();

    if (!a.empty() && a.end()[-1] == '\n') {
        a.erase(a.end()-1);
    }
    if (!b.empty() && b.end()[-1] == '\n') {
        a.erase(b.end()-1);
    }
    out << "(" << a << " || " << b << ")\n";
}
