// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2011, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2011, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */

#include <stdexcept>
#include <iset.hpp>
#include <solver.hpp>
#include <opb_variable.hpp>

using namespace std;
using namespace hcsp;
using namespace hcsp::opb;


void variable::throw_bad_alloc() const
{
    throw bad_alloc();
}

void variable::associate(hcsp::solver & solver)
{
    static iset bool_domain(make_pair(0,1));
    m_id= solver.add_var(bool_domain, name());
}
 
size_t variable::hash() const
{
    size_t accumulated=1;
    for (const char * p= m_name ; *p ; ++p) {
        accumulated *= 1523; // a prime number bigger than 2**(sizeof(char))
        accumulated += *p;
    }
    return accumulated;
}
