// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2013, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2013, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */

#include <pool_alloc.hpp>

using namespace std;
using namespace hcsp;

void pool_alloc_info::reserve_block()
{
    if ( m_free_list )
        return;             // should never be called in this case
    m_free_list= new char[m_total_size];
    
    for (unsigned i=0 ; i != m_entries ; ++i) {
        char **p= reinterpret_cast<char**>(m_free_list+i*m_entry_size);
        *p= (i == m_entries - 1) ? (char*)0 : m_free_list+(i+1)*m_entry_size;
    }    
}

