// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2009, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2009, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */
#include <iostream>
#include "problem.hpp"
#include "problem_impl.hpp"

using namespace std;
using namespace hcsp;

Problem::Problem()
{
    m_pImpl= new Impl;
}

Problem::~Problem()
{
    delete m_pImpl;
    m_pImpl= NULL;                // to catch illegal reuse after destruction.
}

VarProxy Problem::AddVar(int from, int to, const string & varName)
{
    return m_pImpl->AddVar(from, to, varName);
}

Problem::Success Problem::Solve()
{
    return m_pImpl->Solve();
}

void Problem::PrintResult(ostream &out) const
{
    return m_pImpl->PrintResult(out);
}

void Problem::PrintProblem(ostream &out) const
{
    return m_pImpl->PrintProblem(out);
}
