// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2009, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2009, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */
#ifndef HCSP_PROBLEM_IMPL_HPP_
#define HCSP_PROBLEM_IMPL_HPP_

#include <string>
#include <iosfwd>
#include <vector>
#include "utilities.hpp"
#include "problem.hpp"
#include "variable.hpp"

namespace hcsp {
using namespace std;
class VarProxy;
class ProblemImpl  {
  public:
    ProblemImpl();
    ~ProblemImpl();
    VarProxy AddVar(int from, int to, const string & varName);
    Problem::Success Solve();
    void PrintResult(ostream & out);
    void PrintProblem(ostream & out);
  private:
    vector<Variable>   m_variables;
    vector<Constraint> m_constraints;
};
}

#endif // HCSP_PROBLEM_IMPL_HPP_

