// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2010, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2010, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */


#include <proof_print_visitor.hpp>

using namespace std;
using namespace hcsp;

//virtual
void proof_print_visitor::visit_explanation(int explanation_clause_id)
{
    m_collector.print_explanation(m_out, explanation_clause_id);
}

//virtual
void proof_print_visitor::visit_resolution(
    unsigned pivot,
    int resolvent1_id, const clause_data & resolvent1,
    int resolvent2_id, const clause_data & resolvent2,
    int consequent_id, const clause_data & consequent)
{
    m_collector.print_resolution(m_out, pivot,
                                 resolvent1_id, resolvent1,
                                 resolvent2_id, resolvent2,
                                 consequent_id, consequent);
}

//virtual
void proof_print_visitor::visit_initial_resolution(
    unsigned variable, const iset & domain,
    int resolvent_id, const clause_data & resolvent,
    int consequent_id, const clause_data & consequent)
{
    m_collector.print_initial_resolution(m_out, variable, domain,
                                         resolvent_id, resolvent,
                                         consequent_id, consequent);
}
