// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2012, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2012, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */
#ifndef HCSP_C_LIKE_SOLVER_HPP_
#define HCSP_C_LIKE_SOLVER_HPP_

#include <string>
#include <iosfwd>
#include <table_propagators.hpp>
#include <solver.hpp>
#include <parser_context.hpp>

namespace hcsp {
class hcsp_flags;
class c_like_solver : public solver {
  public:
    c_like_solver(std::istream & in,
		  const std::string & file_name,
		  const hcsp_flags & flags,                
		  hcsp::table_propagator_base::memory_manager&);
    virtual iset::value_type evaluate_objective() const
    {
        return m_context.evaluate_objective();
    }
  private:
    parser_context m_context;
};
} // namespace hcsp


#endif // HCSP_C_LIKE_SOLVER_HPP_
