// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2009, Michael Veksler mveksler.technion.ac.il
 *  Copyright (C) 2009, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */
#ifndef HCSP_CONSTRAINT_CONNECTIVITY_INFO_INL_
#define HCSP_CONSTRAINT_CONNECTIVITY_INFO_INL_
#include <constraint_connectivity_info.hpp>
#include <solver.hpp>

namespace hcsp {
inline bool
constraint_connectivity_info::reduced_by_last_activation(unsigned param_index)
    const
{
    unsigned var_index= m_arguments.at(param_index);
    return
        m_p_solver->var_modification_time(var_index) == m_last_activation_time;
}

} // namespace hcsp

#endif // HCSP_CONSTRAINT_CONNECTIVITY_INFO_INL_
