// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2009, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2009, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */
#ifndef HCSP_CSP_HPP_
#define HCSP_CSP_HPP_

#include "problem.hpp"
#include "expr.hpp"

namespace hcsp {
class VarProxy;
class Propagator;
class Constraint {
  public:
    Constraint(Problem & prob, Propagator *pPropagator);
    Constraint & operator<<(const VarProxy &);
    Constraint & operator<<(int);
};
class Propagator {
};
class DiffPropagator : public Propagator {
};
class MinusPropagator : public Propagator {
};

}

#endif // HCSP_CSP_HPP_
