// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2009, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2009, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */
#ifndef HCSP_PROBLEM_HPP_
#define HCSP_PROBLEM_HPP_

#include <string>
#include <iosfwd>
#include "utilities.hpp"

namespace hcsp {
class VarProxy;
class Problem : private no_copy {
  public:
    enum Success { SAT, UNSAT, UNKNOWN };
    Problem();
    ~Problem();
    VarProxy AddVar(int from, int to, const std::string & varName= "");
    Success Solve();
    void PrintResult(std::ostream & out) const;
    void PrintProblem(std::ostream & out) const;
  private:
    class Impl;
    Impl *m_pImpl;
};
}

#endif // HCSP_PROBLEM_HPP_

