// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2009, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2009, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */
#ifndef HCSP_XCSP_SOLVER_HPP_
#define HCSP_XCSP_SOLVER_HPP_

#include <string>
#include <iosfwd>
#include <stdexcept>
#include <solver.hpp>
#include <table_propagators.hpp>

namespace hcsp {
class hcsp_flags;
class xcsp_solver : public solver {
  public:
    xcsp_solver(std::istream & in,
                const std::string & file_name,
                const hcsp_flags & flags,
                table_propagator_base::memory_manager& manager);
};
} // namespace hcsp

#endif // HCSP_XCSP_SOLVER_HPP_
