/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2009, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2009, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */
#include "csp.hpp"
#include <iostream>
#include <sstream>
#include <vector>

using namespace std;
using namespace hcsp;

template <class T>
std::string ToStr(const T& t)
{
  std::ostringstream out;
  out << t;
  return out.str();
}


int main()
{
  Problem prob;
  vector<VarProxy> vars;
  unsigned n=4;

  for (unsigned i=0 ; i < n ; ++i)
    vars.push_back(prob.AddVar(0,n-1, "q"+ToStr(i)));

  for (unsigned i=0 ; i < n ; ++i)
    for (unsigned j=i+1 ; j < n ; ++j) {
      Constraint(prob, new DiffPropagator) << vars[i] << vars[j];
      Constraint(prob, new DiffPropagator) << Minus(vars[i],vars[j]) << i-j;
      Constraint(prob, new DiffPropagator) << Minus(vars[i],vars[j]) << j-i;
    }
  prob.Solve();
  prob.PrintResult(cout);
}
